--[[

WOW does not allow use of 'require', so everything has to be in the Global
namespace. This means libs and modules have to be loaded manually when
running tests because the game does this for us in a real environment.

--]]


dofile('./Constants.lua')
dofile('./Util.lua');
dofile('./Blizzard.lua');
dofile('./Premades.lua');


local B = Winning_Blizzard

local M = {}

local tests = {
    "test_Blizzard",
    "test_Util",
    "test_Premades",
}

M.runtests = function() 
    B.mock_if_missing()
    Winning_Chat_Icon_Texture = "{icon}"
    local passing_tests, failing_tests = 0, 0
    for test_module in pairs(tests) do
        local m = require(tests[test_module])
        for test_name, test_function in pairs(m) do
            local ok, msg = pcall(test_function)
            if ok then
                print(string.format("%s:%s: %s", tests[test_module], test_name, 'OK'))
                passing_tests = passing_tests + 1
            else
                print(string.format("%s:%s: %s", tests[test_module], test_name, 'FAILED'))
                print(string.format("  -> %s", msg))
                failing_tests = failing_tests + 1
            end
        end
    end

    print("\n")
    print(string.format("Total Tests: %s", failing_tests + passing_tests))
    print(string.format("     Passed: %s", passing_tests))
    print(string.format(" !!! Failed: %s", failing_tests))

end


M.runtests()
